/*
 * Blackfin FFTR[h Visual DSP++p
 *
 * Copyright(C) 2012 Kaneko System Co., Ltd.
 *
 * Last Update: 2012/08/22
 *
 * yӁz
 * EǂȂłRɉςĎgp邱Ƃł܂B
 * Ẽ\tgEFA͖ۏ؂łB̃t@CɋLڂĂER[h
 *   gpꍇ́A[U̐ӔCɂčsĂB̎gp
 *   NA[U܂͑O҂ɐQɊւAЂ͈؂̐ӔC
 *   ܂B
 *
 */

#include <blackfin.h>
#include <builtins.h>
#include <filter.h>
#include <window.h>
#include <math.h>
#include <stdint.h>

/* TvO_ */
#define NUM_SAMPLES		(1024)

/* rfft_fr16̈scale_methodŎw肷萔 */
#define SCALE_NONE		(3)				/* FFTXP[OȂ */
#define SCALE_STATIC	(1)				/* FFTÓIXP[O */
#define SCALE_DYNAMIC	(2)				/* FFTIXP[O */

/* fract16́Ashorttypedef. ƌŒ菬_̌^Ƌʂ邽߂
 * wb_t@CŒ`Ă.
 * Visual DSP++ɂ́A32bitgfract32.
 */

/* ֐pobt@ */
static fract16 sf_window[NUM_SAMPLES];

/* ̓f[^pobt@(ADC̃f[^) */
static fract16 sf_input[NUM_SAMPLES];

/* FFT̓f[^pobt@ */
static fract16 sf_fft_input[NUM_SAMPLES];

/* FFTo͌ʗpobt@ */
static complex_fract16 sf_fft_output[NUM_SAMPLES];

/* ]qe[u (KvȃTCÝAFFT̃TCY̔) */
static complex_fract16 sf_twiddle_table[NUM_SAMPLES / 2];

/* ̊֐̏ڍׂ́A"Visual DSP++ Help for Blackfin"sin_fr16QƂĂ */
static fract16 s_sin2pi_fr16(fract16 x)
{ 
	if(x < 0x2000)
	{   /* <0.25  */
		/* first quadrant [0../2):               */
		/* sin_fr16([0x0..0x7fff]) = [0..0x7fff)   */
		return sin_fr16(x * 4);
	}
	else if(x == 0x2000)
	{
		/* = 0.25 */
		return 0x7fff;
	}
	else if (x < 0x6000)
	{
		/* < 0.75  */
		/* if (x < 0x4000)                         */
		/* second quadrant [/2..):             */
		/* -sin_fr16([0x8000..0x0)) = [0x7fff..0)  */
		/*                                         */
		/* if (x < 0x6000)                         */
		/* third quadrant [..3/2):             */
		/* -sin_fr16([0x0..0x7fff]) = [0..0x8000)  */
		return -sin_fr16((0xc000 + x) * 4);
	}
	else
	{
		/* fourth quadrant [3/2..):            */
		/* sin_fr16([0x8000..0x0)) = [0x8000..0)   */
		return sin_fr16((0x8000 + x) * 4);
	}
}


void main(void)
{
	int32_t l_lc;
	int32_t l_block_exponent;
	
	/**********************************/
	/* ֐Ɖ]qe[u̍쐬(Ɏs) */
	
	/* ֐쐬(̃P[Xł̓n~Ogp) */
	gen_hamming_fr16(sf_window, 1, NUM_SAMPLES);
	
	/* ]qe[u쐬(rfft_fr16Ŏgp) */
	twidfftrad2_fr16(sf_twiddle_table, NUM_SAMPLES);

	/**********************************/
	
	/* Kɓ̓f[^쐬
	 * ƂāATvO[g16kHzA1kHz̐g`
	 */
	for(l_lc = 0; l_lc < NUM_SAMPLES; l_lc++)
	{
		sf_input[l_lc] = s_sin2pi_fr16((l_lc * 2048) & 0x7FFF);
	}
	
	/* ̓f[^Ƀn~OK */
	for(l_lc = 0; l_lc < NUM_SAMPLES; l_lc++)
	{
		/* Œ菬_m̏Z(builtin֐gp) */
		sf_fft_input[l_lc] = mult_fr1x16(sf_window[l_lc], sf_input[l_lc]);
	}
	
	/* pFFT */
	rfft_fr16(sf_fft_input, sf_fft_output, sf_twiddle_table, 1, NUM_SAMPLES, &l_block_exponent, SCALE_STATIC);
	
	/* ÓIXP[ȌꍇAl_block_exponentɂlog2(NUM_SAMPLES)i[܂.
	 * 512_FFTȂ9, 1024_FFTȂ10, 2048_FFTȂ11
	 */
}
